;=========================================================================
;Megamari Replay Recorder & Viewer
;Written by ģ(LOVEHINA-AVC) 2006.5
;-------------------------------------------------------------------------
;Develop environment : Windows XP Pro SP2 & MASM32 v8.2 with OllyDBG v1.10
;=========================================================================


.386
.model flat,stdcall
option casemap:none


include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
includelib \masm32\lib\kernel32.lib
include \masm32\include\user32.inc
includelib \masm32\lib\user32.lib
include \masm32\include\comdlg32.inc
includelib \masm32\lib\comdlg32.lib


.DATA?

    hMegamariReplayFile        HANDLE    ?
    lpMegamariReplayBuffer     LPVOID    ?
    dwNumberOfBytesRead        DWORD     ?
    dwNumberOfBytesWritten     DWORD     ?
    iMegamariReplayCounter     UINT      ?
    iMegamariReplaySize        UINT      ?
    iMegamariReplayOffset      UINT      ?
    FileNameBuffer             db        MAX_PATH dup(?)
    PathBuffer                 db        MAX_PATH dup(?)
    bInit                      BYTE      ?


.DATA

    szMegamariMismatch          db    "The version of Megamari.exe is not match with MRRV",0
    szAlreadyRunning            db    "MRRV is already running in memory",0
    szMegamariNotExistOrFailed  db    "Megamari.exe has not found or MRRV could not open it",0
    szMegamariReplayInvalid			db	  "The specified file is an invalid replay file for MRRV",0
    szMegamariReplayFailed      db	  "MRRV could not open the file",0
    szCreateFileFailed          db    "Failed to create the file",0
    szCreateProcFailed          db    "Failed to create process for Megamari",0
    szAccessDenied              db    "File access denied",0
		szUserCancelled             db    "Operation abort",0
    szOutOfMemory               db    "Out of memory",0
    szMutex			                db    "MRRVMtx_0",0
    szMegamariFileName          db    "Megamari.exe",0
    szReplayFilter              db    "Replay file for Megamari (*.rpy)",0,"*.rpy",0,"All files (*.*)",0,"*.*",0,0

    ALIGN    DWORD
    startupinfo     STARTUPINFO            <>
    procinfo        PROCESS_INFORMATION    <>
    ALIGN    DWORD
    context         CONTEXT                <>
    debugevent      DEBUG_EVENT            <>
    ofn             OPENFILENAME           <>

    arrayBreakPoint    dd     004733F7h,0046D1CFh,00470AE3h
    bRespecifyFile     BYTE   FALSE
    bNotHandled        BYTE   FALSE
    bRecordMode        BYTE   FALSE
    bStopMode          BYTE   FALSE
    bKeyRelease        BYTE   TRUE
    bSpeedSwitch       BYTE   FALSE
    Int3Code           BYTE   0CCh

.CONST

    ID_MRRV                 equ    '2RRM'
    Megamari_FILE_SIZE      equ    860160
    REPLAY_FILE_SIZE_MIN    equ    320
    REPLAY_FILE_BUFFER_SIZE equ    128000

.CODE

start:

	invoke	CreateMutex,NULL,NULL,ADDR szMutex
	invoke	GetLastError
	test	eax,eax
	jnz	AlreadyRunning
	invoke	LocalAlloc,LPTR,REPLAY_FILE_BUFFER_SIZE
	test	eax,eax
	jz	OutOfMemory
	mov	lpMegamariReplayBuffer,eax
	invoke	GetCurrentDirectory,MAX_PATH,ADDR PathBuffer
	and	iMegamariReplayOffset,0
	xor	ecx,ecx
  mov	ofn.lStructSize,SIZEOF ofn
  mov	ofn.hwndOwner,ecx
	mov	ofn.lpstrCustomFilter,ecx
	mov	ofn.nFilterIndex,ecx
	mov	ofn.nMaxFile,MAX_PATH
	mov	ofn.lpstrFileTitle,ecx
	mov	ofn.lpstrInitialDir,ecx
	mov	ofn.lpstrTitle,ecx
	invoke	CreateFile,ADDR szMegamariFileName,GENERIC_READ,NULL,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,FILE_FLAG_SEQUENTIAL_SCAN

@@:

	cmp	eax,INVALID_HANDLE_VALUE
	je	MegamariNotExistOrFailed

CheckFileSize:

	mov	ebp,eax
	invoke	GetFileSize,eax,NULL
	cmp	eax,Megamari_FILE_SIZE
	jne	MegamariMismatch
	invoke	CloseHandle,ebp
	mov	eax,lpMegamariReplayBuffer
	mov	BYTE PTR[eax],NULL
	mov	ofn.lpstrFile,eax
	mov	ofn.lpstrFilter,OFFSET szReplayFilter
	mov	ofn.Flags,OFN_HIDEREADONLY
	invoke	GetOpenFileName,ADDR ofn
	test	eax,eax
	jz	UserCancelled
	invoke	CreateFile,lpMegamariReplayBuffer,GENERIC_READ,NULL,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,FILE_FLAG_SEQUENTIAL_SCAN
	cmp	eax,INVALID_HANDLE_VALUE
	jne	ReplayMode
	invoke	CreateFile,lpMegamariReplayBuffer,GENERIC_WRITE,NULL,NULL,CREATE_NEW,FILE_ATTRIBUTE_NORMAL,FILE_FLAG_SEQUENTIAL_SCAN
	cmp	eax,INVALID_HANDLE_VALUE
	je	CreateFileFailed
	mov	bRecordMode,TRUE
	mov	hMegamariReplayFile,eax
	mov	eax,lpMegamariReplayBuffer
	mov	DWORD PTR[eax],ID_MRRV
	mov	iMegamariReplaySize,0FFFFFFFFh
	jmp	CreateGame

ReplayMode:

	mov	hMegamariReplayFile,eax
	invoke	GetFileSize,eax,NULL
	cmp	eax,REPLAY_FILE_SIZE_MIN
	jb	MegamariReplayInvalid
	mov	iMegamariReplaySize,eax
	call	ReplayFileProc
	mov	eax,lpMegamariReplayBuffer
	cmp	DWORD PTR[eax],ID_MRRV
	jne	MegamariReplayInvalid
	
CreateGame:

	mov	bInit,FALSE
	mov	iMegamariReplayCounter,4
	invoke	GetStartupInfo,ADDR startupinfo
	xor	eax,eax
	push	OFFSET procinfo
	push	OFFSET startupinfo
	push	eax
	push	eax
	push	DEBUG_PROCESS or DEBUG_ONLY_THIS_PROCESS
	push	eax
	push	eax
	push	eax
	push	eax
	cmp	bRespecifyFile,TRUE
	je	@f
	push	OFFSET szMegamariFileName
	jmp	CreateProcessCall

@@:

	push	OFFSET FileNameBuffer

CreateProcessCall:

	invoke	SetCurrentDirectory,ADDR PathBuffer
	call	CreateProcess
	test	eax,eax
	jz	CreateProcFailed
	
WaitForDebugEventLoop:

	invoke	WaitForDebugEvent,ADDR debugevent,INFINITE
	cmp	debugevent.dwDebugEventCode,EXIT_PROCESS_DEBUG_EVENT
	je	ExitProcessEvent
	cmp	debugevent.dwDebugEventCode,CREATE_PROCESS_DEBUG_EVENT
	jne	ExceptionEventCheck
	xor	ecx,ecx
	
@@:

	push	ecx
	mov	edx,OFFSET arrayBreakPoint
	invoke	WriteProcessMemory,procinfo.hProcess,[edx + ecx * 4],ADDR Int3Code,1,NULL
	pop	ecx
	inc	ecx
	cmp	ecx,3
	jb	@b
	jmp	DebugContinue
	
ExceptionEventCheck:

	cmp	debugevent.dwDebugEventCode,EXCEPTION_DEBUG_EVENT
	jne	DebugContinue
	cmp	debugevent.u.Exception.pExceptionRecord.ExceptionCode,EXCEPTION_BREAKPOINT
	jne	DebugNotHandled
	cmp bInit,FALSE
	jnz	@f
	mov	bInit,TRUE
	mov	context.ContextFlags,CONTEXT_CONTROL or CONTEXT_INTEGER
	jmp DebugContinue

@@:

	invoke	GetThreadContext,procinfo.hThread,ADDR context
	mov	edx,OFFSET arrayBreakPoint
	xor	ecx,ecx
	
@@:

	mov	eax,[edx + ecx * 4]
	inc	eax
	cmp	context.regEip,eax
	je	@f
	inc	ecx
	cmp	cl,3
	jb	@b
	jmp	DebugNotHandled
	
@@:
	
	test	ecx,ecx
	jne	BrokeInInputProc
	mov	edx,lpMegamariReplayBuffer
	mov	ecx,iMegamariReplayCounter
	cmp	bRecordMode,TRUE
	je	RestoreRandomizeSeed
	mov	eax,[edx + ecx]
	mov	context.regEax,eax
	push	ecx
	lea	ecx,[edx + ecx + 4]
	cmp	DWORD PTR[ecx],0
	je	@f
	invoke	WriteProcessMemory,procinfo.hProcess,004CDDC0h,ecx,SIZEOF DWORD,NULL
	pop	ecx
	add	ecx,4
	jmp	CompleteRandomizeSeedProc

@@:

	pop	ecx
	jmp	CompleteRandomizeSeedProc
	
RestoreRandomizeSeed:

	mov	eax,context.regEax
	mov	[edx + ecx],eax
	push	ecx
	lea	ecx,[edx + ecx + 4]
	invoke	ReadProcessMemory,procinfo.hProcess,004CDDC0h,ecx,SIZEOF DWORD,NULL
	pop	ecx
	add	ecx,4

CompleteRandomizeSeedProc:

	add	ecx,4
	mov	iMegamariReplayCounter,ecx
	sub	context.regEsp,SIZEOF DWORD
	invoke	WriteProcessMemory,procinfo.hProcess,context.regEsp,ADDR context.regEax,SIZEOF DWORD,NULL
	invoke	SetThreadContext,procinfo.hThread,ADDR context
	jmp	DebugContinue
	
BrokeInInputProc:

	cmp	cl,2
	je	BrokeInDICall
	cmp	bStopMode,TRUE
	je	CompleteDICallProc
	mov	edx,iMegamariReplayOffset
	mov	ecx,iMegamariReplayCounter
	add	edx,ecx
	cmp	edx,iMegamariReplaySize
	jae	ExitProcessEvent
	cmp	ecx,REPLAY_FILE_BUFFER_SIZE - 200
	jb	@f
	call	ReplayFileProc
	and	iMegamariReplayCounter,0

@@:

	mov	ecx,iMegamariReplayCounter
	push	ecx
	mov	edx,lpMegamariReplayBuffer
	lea	eax,[edx + ecx]
	push	eax
	cmp	bRecordMode,TRUE
	je	RecordInputStream
	invoke	WriteProcessMemory,procinfo.hProcess,004CF5DCh,eax,SIZEOF DWORD * 7,NULL
	pop	eax
	add	eax,SIZEOF DWORD * 9
	invoke	WriteProcessMemory,procinfo.hProcess,004CF630h,eax,SIZEOF DWORD * 9,NULL
	jmp	CompleteInputProc
	
RecordInputStream:

	invoke	ReadProcessMemory,procinfo.hProcess,004CF5DCh,eax,SIZEOF DWORD * 7,NULL
	pop	eax
	add	eax,SIZEOF DWORD * 9
	invoke	ReadProcessMemory,procinfo.hProcess,004CF630h,eax,SIZEOF DWORD * 9,NULL
	
CompleteInputProc:

	pop	ecx
	add	ecx,SIZEOF DWORD * 16
	mov	iMegamariReplayCounter,ecx

CompleteDICallProc:

	invoke	ReadProcessMemory,procinfo.hProcess,context.regEsp,ADDR context.regEbp,SIZEOF DWORD,NULL
	add	context.regEsp,SIZEOF DWORD
	invoke	SetThreadContext,procinfo.hThread,ADDR context
	jmp	DebugContinue

BrokeInDICall:

	cmp	bStopMode,TRUE
	je	CompleteDICallProc
	mov	edx,iMegamariReplayOffset
	mov	ecx,iMegamariReplayCounter
	add	edx,ecx
	cmp	edx,iMegamariReplaySize
	jae	ExitProcessEvent
	mov	edx,lpMegamariReplayBuffer
	add	edx,ecx
	cmp	bRecordMode,TRUE
	je	RecordEscKey
	invoke	WriteProcessMemory,procinfo.hProcess,004E3489h,edx,SIZEOF BYTE,NULL
	inc	iMegamariReplayCounter
	invoke	ReadProcessMemory,procinfo.hProcess,004E34C1h,ADDR PathBuffer,3,NULL
	cmp	BYTE PTR[PathBuffer],80h
	jne	SpaceNotBePressed
	cmp	bKeyRelease,FALSE
	je	SpaceNotBeReleased
	mov	eax,OFFSET PathBuffer + 1
	cmp	bSpeedSwitch,TRUE
	je	@f
	mov	BYTE PTR[eax],1
	jmp	ChangeRefreshRate

@@:

	mov	BYTE PTR[eax],10h

ChangeRefreshRate:

	invoke	WriteProcessMemory,procinfo.hProcess,004E3648h,eax,SIZEOF BYTE,NULL
	xor	bSpeedSwitch,TRUE
	mov	bKeyRelease,FALSE
	jmp	SpaceNotBeReleased

SpaceNotBePressed:

	mov	bKeyRelease,TRUE

SpaceNotBeReleased:

	cmp	BYTE PTR[PathBuffer + 2],80h
	jne	CompleteDICallProc
	mov	eax,OFFSET PathBuffer + 1
	mov	BYTE PTR[eax],10h
	invoke	WriteProcessMemory,procinfo.hProcess,004E3648h,eax,SIZEOF BYTE,NULL
	mov	bStopMode,TRUE
	jmp	CompleteDICallProc

RecordEscKey:

	invoke	ReadProcessMemory,procinfo.hProcess,004E3489h,edx,SIZEOF BYTE,NULL
	inc	iMegamariReplayCounter
	jmp	CompleteDICallProc


DebugNotHandled:

	;cmp	bNotHandled,0
	;jne	@f
	;mov	bNotHandled,1
	invoke	ContinueDebugEvent,debugevent.dwProcessId,debugevent.dwThreadId,DBG_EXCEPTION_NOT_HANDLED
	jmp	WaitForDebugEventLoop
	
@@:

	invoke	TerminateProcess,procinfo.hProcess,0
	invoke	ExitProcess,99
 
DebugContinue:

	invoke	ContinueDebugEvent,debugevent.dwProcessId,debugevent.dwThreadId,DBG_CONTINUE
	jmp	WaitForDebugEventLoop
	
ExitProcessEvent:

	cmp	bRecordMode,TRUE
	jne	@f
	call	ReplayFileProc

@@:
	
	invoke	ExitProcess,0

AlreadyRunning:

	invoke	MessageBox,NULL,NULL,ADDR szAlreadyRunning,NULL
	invoke	ExitProcess,1
	
MegamariMismatch:

	invoke	MessageBox,NULL,ADDR szMegamariMismatch,NULL,NULL
	invoke	ExitProcess,2
	
OutOfMemory:

	invoke	MessageBox,NULL,ADDR szOutOfMemory,NULL,NULL
	invoke	ExitProcess,3

AccessDenied:

	invoke	MessageBox,NULL,ADDR szAccessDenied,NULL,NULL
	invoke	ExitProcess,4
	
CreateProcFailed:

	invoke	MessageBox,NULL,ADDR szCreateProcFailed,NULL,NULL
	invoke	ExitProcess,5

UserCancelled:

	invoke	MessageBox,NULL,ADDR szUserCancelled,NULL,NULL
	invoke	ExitProcess,6

CreateFileFailed:

	invoke	MessageBox,NULL,ADDR szCreateFileFailed,NULL,NULL
	invoke	ExitProcess,7
	
MegamariReplayInvalid:

	invoke	MessageBox,NULL,ADDR szMegamariReplayInvalid,NULL,NULL
	invoke	ExitProcess,8

MegamariNotExistOrFailed:

	invoke	MessageBox,NULL,ADDR szMegamariNotExistOrFailed,NULL,NULL
	invoke	ExitProcess,9

ReplayFileProc:

	mov	ecx,iMegamariReplayCounter
	cmp	bRecordMode,TRUE
	je	WriteFileProc
	add	iMegamariReplayOffset,ecx
	mov	eax,iMegamariReplaySize
	sub	eax,iMegamariReplayOffset
	cmp	eax,REPLAY_FILE_BUFFER_SIZE
	jbe	@f
	mov	eax,REPLAY_FILE_BUFFER_SIZE

@@:

	push	eax
	invoke	SetFilePointer,hMegamariReplayFile,iMegamariReplayOffset,NULL,FILE_BEGIN
	pop	eax
	invoke  ReadFile,hMegamariReplayFile,lpMegamariReplayBuffer,eax,ADDR dwNumberOfBytesRead,NULL
	test	eax,eax
	jz	AccessDenied
	retn

WriteFileProc:

	push	ecx
	invoke	SetFilePointer,hMegamariReplayFile,iMegamariReplayOffset,NULL,FILE_BEGIN
	invoke  WriteFile,hMegamariReplayFile,lpMegamariReplayBuffer,iMegamariReplayCounter,ADDR dwNumberOfBytesRead,NULL
	pop	ecx
	add	iMegamariReplayOffset,ecx
	test	eax,eax
	jz	AccessDenied
	retn
	
end	start

	